#version 400 compatibility

#define WANG_HASH
//#define OLD_FRAG

#include "MathUtils.frag"
#include "IQPath-DE.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]
uniform int ColorIterations;  slider[0,2,100]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
if (n<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,dot(z,z))));
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}
























#preset Default
FOV = 0.6
Eye = -1.139161,-1.163418,0.5177186
Target = 0.2670447,0.279127,0.6089966
Up = -0.0315444,-0.0294333,0.9511258
EquiRectangular = false
FocalPlane = 0.745614
Aperture = 0.0012903
ApertureNbrSides = 5
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1
Gamma = 1
ToneMapping = 2
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 6
AntiAliasScale = 3
RayBounces = 3 Locked
RaySteps = 768 Locked
FudgeFactor = 0.1
HitDistance = 0.000117
MaxDepth = 2 Locked
Mat_Color = 0.4980392,0.4980392,0.4980392
Mat_Refl = 0.1
Mat_ReflExp = 0.99
UseTexture = true
DeTex = texture.jpg
DeTexScale = 0.8
DeTexExposure = 1
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.8,0.5,5
SpotLightDir = 0.35802,0.62962
SpotSize = 10
SpotExp = 0.6667633
BgColor = 0.231373,0.329412,0.458824,3
Ambience = 2
Fog = 0.5
GRIter = 4
GRPower = 1
Iterations = 3
Scale = 2.593103
Offset = 1.230216,1.402878,0
Use_Floor = false
ColorIterations = 4
#endpreset

